<?php
namespace nulib\db\pgsql;

use nulib\db\_private\_base;
use nulib\db\_private\_create;
use nulib\db\_private\_delete;
use nulib\db\_private\_generic;
use nulib\db\_private\_insert;
use nulib\db\_private\_select;
use nulib\db\_private\_update;
use nulib\db\_private\Tbindings;
use nulib\ValueException;

class query extends _base {
  use Tbindings;

  const DEBUG_QUERIES = false;

  /**
   * @return resource
   */
  function _exec($db) {
    if (static::DEBUG_QUERIES) { #XXX
      error_log($this->sql);
      //error_log(var_export($this->bindings, true));
    }
    if ($this->bindings !== null) {
      #XXX corriger les bindings et la requête *dans le constructeur*
      $result = pg_query_params($db, $this->sql, $this->bindings);
    } else {
      $result = pg_query($db, $this->sql);
    }
    if ($result === false) throw PgsqlException::last_error($db);
    return $result;
  }
}
